Imports System.IO

Public Class Form1
    Dim XfirePath As String = Reg.Read("SOFTWARE\Xfire")
    Dim XfireEXEp As String = "xfire"
    Dim XfireEXE As String = XfirePath & "\" & XfireEXEp & ".exe"
    Dim XfireINI As String = XfirePath & "\xfire_games.ini"
    Dim XfireID As String = "4178"
    Dim defMsg As String = String.Empty

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        AlterConfigIfVista()
        If XfirePath = "" Then
            txtXfirePath.Enabled = True
            txtXfirePath.Text = "Xfire Not Found"
            lblMsg.Text = "Xfire must be installed before using this patcher."
        Else
            txtXfirePath.Text = XfirePath
            If File.Exists(XfireINI) Then
                chkRGInstalled.Enabled = True
                chkDX9Installed.Enabled = True
                btnRunPatch.Enabled = True
                If INI.Read(XfireINI, XfireID & "_1", "LauncherExe") = "game2.exe" Then
                    chkRGInstalled.Checked = True
                End If
                If INI.Read(XfireINI, XfireID & "_1", "InGameRenderer") = "D3D9" Then
                    chkDX9Installed.Checked = True
                End If
                lblMsg.Text = "Xfire found! Prepared to patch on demand."
            Else
                lblMsg.Text = "Xfire found, unable to patch (missing xfire_games.ini)"
            End If
            defMsg = lblMsg.Text
        End If
    End Sub

    Private Sub AlterConfigIfVista()
        If Not Environment.GetEnvironmentVariable("programdata") = "" Then
            XfireINI = Environment.GetEnvironmentVariable("programdata") & "\xfire\xfire_games.ini"
        End If
    End Sub

    Private Sub btnRunPatch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRunPatch.Click
        btnRestartXfire.Enabled = False
        btnRestartXfire.Visible = False
        lblMsg.Text = "Patching..."
        Dim LauncherExe As String = "game.exe"
        Dim InGameRenderer As String = "D3D8"
        pbPatch.Value = 0
        Dim max As Integer = pbPatch.Maximum
        Dim parts As Integer = 5
        Dim part_size As Integer = Math.Round(max / parts, 0)
        If chkRGInstalled.Checked = True Then
            LauncherExe = "game2.exe"
        End If
        If chkDX9Installed.Checked = True Then
            InGameRenderer = "D3D9"
        End If
        If File.Exists(XfireINI) Then
            pbPatch.Value += part_size
            INI.Write(XfireINI, XfireID & "_1", "LauncherExe", LauncherExe)
            pbPatch.Value += part_size
            INI.Write(XfireINI, XfireID & "_1", "InGameRenderer", InGameRenderer)
            pbPatch.Value += part_size
            INI.Write(XfireINI, XfireID & "_2", "LauncherExe", LauncherExe)
            pbPatch.Value += part_size
            INI.Write(XfireINI, XfireID & "_2", "InGameRenderer", InGameRenderer)
            pbPatch.Value += part_size
            lblMsg.Text = "Patch operation completed! Restart Xfire for changes to take effect."
            btnRestartXfire.Enabled = True
            btnRestartXfire.Visible = True
        Else
            lblMsg.Text = "Patch Failed (xfire_games.ini not found)"
        End If
    End Sub

    Private Sub btnRestartXfire_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRestartXfire.Click
        lblMsg.Text = "Restarting Xfire..."
        Dim myProcesses As Process() = Process.GetProcessesByName(XfireEXEp)
        Dim myProcess As Process
        For Each myProcess In myProcesses
            myProcess.Kill()
            myProcess.WaitForExit()
        Next myProcess
        Shell(XfireEXE, AppWinStyle.NormalFocus, False)
        lblMsg.Text = "Restarted."
        btnRestartXfire.Enabled = False
        btnRestartXfire.Visible = False
        lblMsg.Text = defMsg
    End Sub
End Class
