Public Class INI
    Public Declare Unicode Function WritePrivateProfileString Lib "kernel32" _
        Alias "WritePrivateProfileStringW" (ByVal lpApplicationName As String, _
        ByVal lpKeyName As String, ByVal lpString As String, _
        ByVal lpFileName As String) As Int32
    Public Declare Unicode Function GetPrivateProfileString Lib "kernel32" _
    Alias "GetPrivateProfileStringW" (ByVal lpApplicationName As String, _
    ByVal lpKeyName As String, ByVal lpDefault As String, _
    ByVal lpReturnedString As String, ByVal nSize As Int32, _
    ByVal lpFileName As String) As Int32
    Public Overloads Shared Function Read(ByVal Path As String, ByVal SectionName As String, ByVal KeyName As String, ByVal DefaultValue As String) As String
        Dim n As Int32
        Dim sData As String
        sData = Space$(1024)
        n = GetPrivateProfileString(SectionName, KeyName, DefaultValue, _
        sData, sData.Length, Path)
        If n > 0 Then
            Read = sData.Substring(0, n)
        Else
            Read = ""
        End If
    End Function
    Public Overloads Shared Function Read(ByVal Path As String, ByVal SectionName As String, ByVal KeyName As String) As String
        Return Read(Path, SectionName, KeyName, "")
    End Function
    Public Overloads Shared Function Read(ByVal Path As String, ByVal SectionName As String) As String
        Return Read(Path, SectionName, Nothing, "")
    End Function
    Public Overloads Shared Function Read(ByVal Path As String) As String
        Return Read(Path, Nothing, Nothing, "")
    End Function
    Public Shared Sub Write(ByVal Path As String, ByVal SectionName As String, ByVal KeyName As String, ByVal NewValue As String)
        Call WritePrivateProfileString(SectionName, KeyName, NewValue, Path)
    End Sub
End Class
